#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>
#include <time.h>

#include "treelong.h"
#include "nodelong.h"

void PrintCount(int h,long KNr);

int main(int argc, char ** argv){
   int heigh=6;
   simpleNodeLong *nNode;
   EnhTreeLong    Tree;
   int  i;
   long j,l,m,n,o,s;

   if(argc==2) heigh=atoi(argv[1]);

   j=0;
   for(i=0;i<heigh;i++){
      // Die zu fllende Ebene des Baums
      l=((long)1)<<i;
      for(n=0;n<l;){
         m=((long)1)<<(heigh-1);
         s=m;
         // vom MSB her kommend die Bits abtasten
         for(o=(l>>1);o>0;o>>=1){
            if(o&n)  // entspr. Bit gesetzt
               m=((m<0)?-m:m)/2;
            else     // Bit gelscht
               m=((m<0)?m:-m)/4;

            if(!m) break;
            s+=m;
            }
         if(m){
            PrintCount(i,s);
            j++;
            nNode=new simpleNodeLong (s);
            if(nNode==NULL){
               cout << "\nUffff, dat is zuviel!!!" << endl;
               return 0;
               }
            Tree.add(nNode);
            n++;
            }
         else n+=o;
         }
      }
   cout << "Hhe: "          << setw(6)  << i
        << "  Knotenummer: " << setw(10) << s << endl;
   Tree.print();
   cout << "Knotenanzahl: " << j << endl;
   return 0;
   }

void PrintCount(int h,long KNr){
   static time_t Seconds;

   if(time(NULL)!=Seconds){
      cout << "Hhe: "          << setw(6)  << ++h
           << "  Knotenummer: " << setw(10) << KNr
           << '\r' << flush;
      Seconds=time(NULL);
      }
   }

