/*
 * Copyright (C) 1997 Wolfgang Moser
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "menues.h"

void menues::errormsg(void)const{
   gotozs(49,11);
   cerr << "Fehlfunktion whrend der letzten Aktion" << flush;
   }

int menues::readchoice(signed char &inp, const char *const ausw)const{
unsigned int i;

   do{
      gotozs(46,11);
      cin.get(inp);
      i=0;
      if(inp!='\n') while (cin.get()!='\n') i++;
      if(i){
			/* -128 existiert nicht als char,
			 * denn es entsteht aus 128 und
			 * dem unren Operator "-" und 128
			 * ist als char nicht darstellbar,
			 * sondern nur als unsigned char
			 */
         inp=(-127+1);
         return 0;
         }
      clrlns(46,5);
      }while (!included(inp,ausw));
   return 1;
   }

const int menues::included(const char c, const char *cPtr)const{
   while(*cPtr!='\0') if(*(cPtr++)==c) return 1;
   return 0;
   }

void menues::clrlns(const unsigned int ab, unsigned int anz) const{
   for(;anz--;) cout << "\x1b[" << ab+anz << ";1H\x1b[K" << flush;
   cout << "\x1b[1;1H" << flush;
   }
